


/// Thanks to Peter "sehr Ocker" for this great quick hack!



#include "fasta.h"

// ==============================================================
fasta_reader::~fasta_reader()
// ==============================================================
{
	if (file_open)
		fclose (fp_);
	file_open = false;
}

// ==============================================================
fasta_reader::fasta_reader ()
// ==============================================================
    :   fp_ (0), state_ (Void)
{
	fp_ = stdin;
	file_open = false;
	 //    if (!fp_)
    //    MSFATAL ("Cannot open '%s' for reading.", filename.c_str());
}   

// ==============================================================
fasta_reader::fasta_reader (const std::string &filename)
// ==============================================================
    :   fp_ (0), state_ (Void)
{
    fp_ = fopen (filename.c_str(), "rb");
	 file_open = true;
	 //    if (!fp_)
    //    MSFATAL ("Cannot open '%s' for reading.", filename.c_str());
}   

// ==============================================================
void fasta_reader::open (const std::string &filename)
// ==============================================================
{
	if (file_open)
		fclose (fp_);
	
    fp_ = fopen (filename.c_str(), "rb");
	 file_open = true;
	 //    if (!fp_)
    //    MSFATAL ("Cannot open '%s' for reading.", filename.c_str());
}   


// ==============================================================
int             fasta_reader::get_seq (std::string &header, std::string &seq)
// ==============================================================	
{
    int         result = -1;    // 0 = eof, 1 = good seq.

    //if (state_ != Void)
    //    MFATAL ("state_ != VOID");

    header.clear ();
    seq.clear ();

    while (result == -1)
    {
        int     c = fgetc (fp_);

        switch (state_)
        {
            case Void:
                switch (c)
                {
                    case EOF:
                        result = 0;
                        state_ = Void;
                        break;

                    case ' ': case '\t': case '\n': case '\r':
                        break;

                    case '>':
                        state_ = Header;
                        header.push_back (c);
                        break;
            
                    default:
							  //MFATAL ("state_ Void, invalid input char='%c' (dec=%d)", c, c);
                        break;
                }
                break;

            case Header:
                switch (c)
                {
                    case EOF:
                        result = 0;
                        break;

                    case '\n': case '\r':
                        state_ = Data;
                        break;

                    case '\001':    // ^A or Ctrl-A
							  //MWARN ("header contains Ctrl-A character (after %s)", header.c_str());
                        break;
    
                    default:
                        header.push_back (c);
                        break;
                }
                break;

            case Data:
					if (c=='>') {
						state_ = Void;
						ungetc (c, fp_);
						result = 1;
					} else if (c==EOF) {
						result = 1;
						state_ = Void;
					} else if ((c>='a' && c<='z') || (c>='A' && c<='Z')) {
						seq.push_back(c);
					}
                break;

            default:
					//MFATAL ("illegal state %d", state_);
                break;
        }
    }

    return result;
}


