/* global variables concerning user options */
#include "util.h"


int case_sensitive;
int grep_forward;
int grep_backward;
char* output_file_name;
int param_pos;
int verbose;
int append;
int show_p_value;
int show_E_value;
int text_flipped;
int error;
int extend_output;
int extend_prefix;
int extend_suffix;



/* ENTHAELT ALLE DIREKTEN INFORMATIONEN UEBER DIE
	SEQUENZEN, WELCHE AUS DEN INPUT-DATEIEN EINGELESEN WERDEN; */
struct seq_type {
	char *text_name;                     /* Global: Name der Textsequenz (Genom); */
	char *text;                          /* Global: Textsequenz; */
	char *all_text;                      /* Global: Textsequenz; */
	int n_all;                           /* Global: Laenge der Textsequenz; */
	int n;                               /* Global: Laenge der Textsequenz; */
	char **pattern;                      /* Global: Alle Pattern; */
	int *m;                              /* Global: Laenge der einzelnen Pattern; */
	int anz_pattern;                     /* Global: Anzahl aller Pattern; */
	int *l_bound;                        /* Global: Lower-Bound fuer Gaps zwischen 2 Fragmenten; */
	int *u_bound;                        /* Global: Upper-Bound fuer Gaps zwischen 2 Fragmenten; */ 
	int *mm_bound;                       /* Global: Obere Grenze fuer die Anzahl der Mismatches beim Pattern Matching; */
	int pInf;                            /* Global: Index der informativsten (laengsten) Sequenz;    */
	int *sumLeftRight;                   /* Global: Bounds fuer 'pInf'; */
	int *m_max;                          /* Global: Laengstes Pattern mit 'p'<'pInf' sowie das mit 'p'>'pInf'; */
	unsigned char **match_table;         /* Global: Welche Letter matchen welche? */
	unsigned char *index_table;          /* Global: Ordnet jedem char-Zeichen einen Index aus 'match_table' zu; */
	unsigned char *compl_table;          /* Global: Zuordnung des komplem. Zeichens zum Flippen der Sequenz; */
	int num_of_seqs;                     /* Global: Number of sequences (i.e., seq headers) in the Fasta file; */
	char** seq_begs;                     /* Global: Beginning position of the individual sequences in the Fasta file; */
	char** name_begs;                    /* Global: Beginning position of the individual sequence headers in the Fasta file; */
	int* seq_lengths;                    /* Global: Length of the individual sequences in the Fasta file; */
	char text_dir;                       /* Global: current direction ('f' or 'b') that is currently processed; */
	int** di_frequencies;                /* Global: Relative dinucleotide frequencies; */
	int* frequencies;                    /* Global: Relative nucleotide frequencies; */
	
};


/* UM DIE ZUGRIFFE AUF FELDER BESSER ZU VERSTEHEN; */
enum left_right{
	LEFT = 0,
	RIGHT = 1,
	LEFTANDRIGHT = 2
};


/* AUFRUFMETHODEN; */
void readInput(int anz_input, char **input, struct seq_type *seq);

void get_dinucletoide_freq(struct seq_type *seq);
